#include "SortPicts.h"
#include "StandardMenus.h"

extern short	gSortAlgorithm;

void	SortPicts::UseSortFunc( SortFuncPtr sort)
{
	UseUpdateFunc( ::UpdateSortPict);
	
	sortFunc = sort;
}

void	SortPicts::Sort( void)
{	
	short		sortAlgorithm;
	
	sortAlgorithm = gSortAlgorithm;
	if( sortAlgorithm == iRandomSort)
		sortAlgorithm = (short) Random( iRandomSort -2);

	if ( !coplandTask )
		UseSortData();
	
	switch (sortAlgorithm)
	{
		case	iQuickSort:
			UseSortFunc( ::QSort);
			break;
		case	iShellSort:
			UseSortFunc( ::ShellSort);
			break;
		case	iHeapSort:
			UseSortFunc( ::HeapSort);
			break;
		
		default:
			UseSortFunc( ::QSort);
			break;
	}
	(*sortFunc)( this);
	Update();
		
	if ( !coplandTask )
	{	
		UnuseSortData();
	}
	
}
