/*
	File:		App.cp

	Contains:	Boilerplate application-specific code.
				
	Written by: Dave Falkenburg

	Copyright:	 1993-94 by Dave Falkenburg, all rights reserved.

	Change History (most recent first):
	 
 */

#include "Sprocket.h"
#include "SortPicts.h"

#include <Devices.h>
#include <Resources.h>
extern	MenuHandle		gPicturesMenu;
extern short			gSortAlgorithm;
extern Boolean			gUseCoplandTasks;

//	Function Prototypes:

void	AboutBox(void);
void	OpenExistingDocument(void);

extern	unsigned long	gBackgroundSleepQuantum;

OSErr
SetupApplication(void)
	{
	//	we pick a greedy sleep time because we suck
	
	gBackgroundSleepQuantum = 15;
	
	InitCursor();
	return	noErr;
	}

void
TearDownApplication(void)
	{
	//	Not much to do yet.
	}


//short	gCurrentIterationsItem = 1;
//long	gIterationsConstants[] = { 250, 500, 1000, 
//							2000, 5000, 10000, 50000, 100000};
							
void
HandleMenu(TWindow * /* topWindowObj */, long menuCode)
	{
	short	menu = (short) (menuCode >> 16);
	short	item = (short) (menuCode & 0xffff);
	MenuHandle	sortAlgorithmMenu;
	Str255	deskAccName;
	SortPicts		*newWindow;
	Str255	menuSelection;
	
	switch (menu)
		{
		case	mApple:
			switch (item)
				{
				case	iAbout:
					AboutBox();
					break;
					
				default:
					GetMenuItemText(GetMenuHandle(mApple),item,deskAccName);
					(void) OpenDeskAcc(deskAccName);
					break;
				}
			break;
			
		case	mSprocketFileMenu:
			switch (item)
				{
				case	iNewSortingPict:
					CreateNewDocument();
					break;
				
				case	iCloseWindow:
					HandleClose(FrontNonFloatingWindow());
					break;
					
				case	iQuitSortPicts:
					gDone = true;
					break;
					
				default:
					break;
				}
			break;
		
		case	mSortAlgorithm:
			sortAlgorithmMenu = GetMenuHandle( mSortAlgorithm );
			if( sortAlgorithmMenu )
			{
				if ( item == iUseCoplandTasks )
				{
					gUseCoplandTasks = gUseCoplandTasks ? false : true;
					CheckItem( sortAlgorithmMenu, iUseCoplandTasks, gUseCoplandTasks );
				}
				else
				{
					CheckItem( sortAlgorithmMenu, gSortAlgorithm, false );
					CheckItem( sortAlgorithmMenu, item, true );
					gSortAlgorithm = item;
				}
			}
			break;
		

		
		case	mPictureMenu:
			GetMenuItemText( gPicturesMenu, item, menuSelection);
			if( menuSelection[0] == 0)
				break;
			
			newWindow = new SortPicts( menuSelection);
			break;
			
		default:
			break;
		}
		
	HiliteMenu(0);
	}


void
AboutBox(void)
	{
	Handle			versionHandle;
	StringPtr		nullStr = (StringPtr) "\p";
	StringPtr		shortVersionString = nullStr;
	short			itemHit;
	
	versionHandle = GetResource('vers',1);
	if (versionHandle)
		shortVersionString = (StringPtr) ((char *) *versionHandle + 6);
	ParamText(shortVersionString,nullStr,nullStr,nullStr);
	ReleaseResource(versionHandle);

#ifndef	powerc
	itemHit = StandardAlert(kAboutBoxFor68K);
#else
	itemHit = StandardAlert(kAboutBoxForPowerPC);
#endif

	if (itemHit == iCreditsButton) {
		StandardAlert(kCreditsBox);
	}
}


void
WriteLocalClipboardToScrap(void)
	{
	}


void
ReadLocalClipboardFromScrap(void)
	{
	}


OSErr
CreateNewDocument(void)
	{
	SortPicts	*aNewWindow;
	
	aNewWindow = new SortPicts;
		
	if (aNewWindow)
		return noErr;
	else
		{
		return memFullErr;
		}
	}


OSErr
OpenDocument(LetterDescriptor * /* theDocument */, void * /*unused*/)
	{
	return CreateNewDocument();	//	cheat for now
	}


OSErr
PrintDocument(LetterDescriptor * /* theDocument */, void * /*unused*/)
	{
	return noErr;
	}


Boolean
QuitApplication(void)
	{
	return true;
	}
